<template>
    <div class="container">
        <div class="head">
            <img class="goback" :src="goback"  @click="onClickLeft" alt="">
            <img class="logo" :src="logo" alt="">
        </div>
        <div class="main">
            <div class="title">很高兴见到你</div>
            <div class="form">
                <div class="mes">
                    <input type="text" placeholder="请输入您的用户名" v-model="userName">
                </div>
                <div class="mes">
                    <input type="tel" placeholder="请输入您的手机号" v-model="mobileNo">
                </div>
                <div class="code">
                    <div class="mes" style="margin-bottom:11px;">
                        <input type="text" placeholder="请输入验证码" v-model="code">
                    </div>
                  <div class="mes" @click="refreshCode" style="margin-bottom:11px;width:50%;display: flex;justify-content: center;align-items: center" ref="codeMes">
                  <SIdentify :identifyCode="identifyCode"
                             :contentWidth="127" @click="refreshCode"></SIdentify>
                </div>
                </div>
                <div class="mes">
                    <input type="password" placeholder="请输入您的密码" v-model="password">
                </div>
                <div class="mes" style="margin-bottom:15.5px;">
                    <input type="password" placeholder="再次确认您的密码" v-model="repassword">
                </div>
                <div class="read">
                  <template>
                    <el-checkbox v-model="checked">
                     我已阅读并同意 <span>《拼图内容授权协议》</span>、<span>《使用条款》</span>与<span>《隐私政策》</span>
                    </el-checkbox>
                  </template>
                </div>
                <div class="btn" @click="register()">注 册</div>
            </div>
        </div>
    </div>
</template>

<script>
import logo from '@/assets/logo.png'
import { Toast } from 'vant'
import SIdentify from '@/views/Identify'
import goback from '@/assets/detail/goback_first.png'

export default {
  name: 'Register',
  data () {
    return {
      logo,
      goback,
      userName: '',
      mobileNo: '',
      code: '',
      password: '',
      repassword: '',
      checked: false,
      mes: '',
      identifyCodes: '1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ',
      identifyCode: ''
    }
  },
  mounted () {
    this.identifyCode = ''
    this.makeCode(this.identifyCodes, 4)
  },
  computed: {},
  methods: {
    randomNum (min, max) {
      return Math.floor(Math.random() * (max - min) + min)
    },
    refreshCode () {
      this.identifyCode = ''
      this.makeCode(this.identifyCodes, 4)
    },
    makeCode (o, l) {
      for (let i = 0; i < l; i++) {
        this.identifyCode += this.identifyCodes [
          this.randomNum(0, this.identifyCodes.length)
        ]
      }
      console.log(this.identifyCode)
    },
    onClickLeft () {
      this.$router.push('/first')
    },
    register: async function () {
      if (!this.userName) {
        Toast('请输入您的用户名')
        return
      }
      if (this.userName.length > 18) {
        Toast('用户名长度不应超过18个字符')
        return
      }
      if (!this.mobileNo) {
        Toast('请输入您的手机号')
        return
      }
      if (this.mobileNo.length !== 11) {
        Toast('手机号输入有误')
        return
      }
      if (!this.code) {
        Toast('请输入验证码')
        return
      }
      if (this.code.toLowerCase() !== this.identifyCode.toLowerCase()) {
        Toast('验证码错误')
        return
      }
      if (!this.password) {
        Toast('请输入您的密码')
        return
      }
      if (this.password.length > 30) {
        Toast('密码长度不应超过30个字符')
        return
      }
      if (!this.repassword) {
        Toast('再次确认您的密码')
        return
      }
      if (this.password !== this.repassword) {
        Toast('两次密码不一致')
        return
      }
      if (!this.checked) {
        Toast('请选择同意协议')
        return
      }
      this.mes = await this.$api.register(this.userName, this.password, this.mobileNo)
      console.log(this.mes)
      if (this.mes.data.code === 201) {
        Toast('注册成功')
        this.$router.push('/first')
      } else {
        Toast(this.mes.data.message)
      }
    }
  },
  components: {
    SIdentify: SIdentify
  }
}
</script>
<style scoped lang="less">
.container {
  background: #3170ff;
  display: flex;
  flex-direction: column;
  .head{
    .goback{
      width:20px;
      height:16px;
      position: fixed;
      top:16px;
      left:14px;
    }
    .logo{
      padding:29.5px 40.4% 24.5px 43.1%;
      width: 62px;
      height:76.5px;
    }
  }
  .main {
    background: #fff;
    border-top-left-radius: 45px;
    border-top-right-radius: 45px;
    .title{
      padding-top: 50.5px;
      font-size: 17px;
      font-weight: bold;
      color:#285ed8;
      text-align: center;
      letter-spacing:7.25px;
      text-indent: 7.25px;
    }
    .form {
      padding: 51px 15.6% 0px 16.9%;
      .mes {
        overflow: hidden;
        display:flex;
        align-items: center;
        border-radius: 4px;
        border:1px solid #dcdcdc;
        height:37.5px;
        margin-bottom: 11.5px;
        input {
          padding-left:14.5px;
          font-size: 13px;
          letter-spacing: 1.5px;
          width: 100%;
          border:none;
          outline:none;
          cursor:text;
        }
        input::-webkit-input-placeholder{
          color: #a8a8a8;
        }
      }
      .code {
        display: flex;
        justify-content: space-between;
        div {
          width: 45%;
        }
      }
      /deep/.s-canvas{
        width:126px;
        height:37.5px;
        display: flex;
        justify-content: center;
        align-items: center;
      }
      .btn {
        display:flex;
        align-items: center;
        justify-content: center;
        height:32.5px;
        font-size: 14.9px;
        font-weight: bold;
        background:#3170ff ;
        color: #fff;
        border-radius: 4px;
        letter-spacing:12.6px;
        text-indent: 12.6px;
      }
      .read {
        margin-bottom: 34.5px;
        .el-checkbox{
          /deep/.el-checkbox__input {
                  height: 11px;
                  width: 11px;
                  position: absolute;
                  left:4px;
                  top:0.6px;
                  .el-checkbox__inner {
                    height: 11px;
                    width: 11px;
                    border-radius: 4px;
                  }
          }
          /deep/.el-checkbox__inner::after{
            height: 6px;
            width: 3px;
            border-radius: 4px;
            position: absolute;
            left:3px;
            top:0;
          }
          /deep/.el-checkbox__label{
            vertical-align:middle;
            padding:0;
            text-indent: 1.6em;
            line-height: 15px;
            font-size:10px;
            color:#4D4D4D;
            letter-spacing: -0.4px;
            font-weight:lighter;
            white-space: pre-wrap;
          }
        }
      }
      span {
        color: #3170ff ;
      }
    }
  }
}
</style>
